# This file was *autogenerated* from the file class.sage.
from sage.all_cmdline import *
import bz2, os

def _pad_int_str(s,n):
    return "0"*(n-len(str(s))) + str(s)

def fundamental_discriminant(D):
    DK = squarefree_part(D)
    c = D.div(DK).isqrt()
    if DK.mod(Integer(4)) in (Integer(0),Integer(1)):
       return DK, c
    return Integer(4)*DK, c.div(Integer(2))

disc_class = {}
ClassBound = Integer(1024)
for DIR in os.listdir('.'):
    if DIR != 'Class' and os.path.isdir(DIR):
        D1, D2 = DIR.split("-")
        D1 = int(D1)
        D2 = int(D2)
        for FILE in os.listdir(DIR):
            SPLIT_FILE = FILE.split('.')
            if SPLIT_FILE[Integer(2)] == 'dbz':
                D = -int(SPLIT_FILE[Integer(1)].split('-')[Integer(0)])+Integer(1)
                f = bz2.BZ2File(DIR + '/' + FILE)
                seq = f.read().split('\n');
                for i in range(Integer(5000)):
                    h_invs_str = seq[i].strip()
                    if len(h_invs_str) == Integer(0):
                        h_invs = [ ]
                    else:
                        h_invs = [ int(hi) for hi in h_invs_str.split(' ') ]
                    if i % Integer(2) == Integer(0):
                        D += -Integer(3)
                    else:
                        D += -Integer(1)
                    if h_invs != []:
                        h = Integer(1)
                        for hi in h_invs:
                            h *= int(hi)
                        if h <= ClassBound:
                            if disc_class.has_key(h):
                                disc_class[h].append(tuple([D] + h_invs))
                            else:
                                disc_class[h] = [tuple([D] + h_invs)]
        print "Finished reading discriminant %s-%s" % (D1, D2)

for h in range(Integer(1),ClassBound+Integer(1)):
    hhh = _pad_int_str(str(h),Integer(6))
    filename = 'Class/class.' + hhh + '.db'
    f = open(filename, 'w')
    try:
        class_discs = disc_class[h]
    except:
        class_discs = []
    for class_seq in class_discs:
        D = class_seq[Integer(0)]
        _, c = fundamental_discriminant(D)
        f.write("%s %s" % (D, c))
        for hi in class_seq[Integer(1):]:
            f.write(" %s" % hi)
        f.write("\n");
    f.close()
    os.system('bzip2 -c ' + filename + ' > ' + filename + 'z')
    os.system('chmod a+r ' + filename + 'z')
    os.system('rm ' + filename)
