import bz2, os

def _pad_int_str(s,n):
    return "0"*(n-len(str(s))) + str(s)

def fundamental_discriminant(D):
    DK = squarefree_part(D)
    c = D.div(DK).isqrt()  
    if DK.mod(4) in (0,1):
       return DK, c 
    return 4*DK, c.div(2)

disc_class = {}
ClassBound = 1024 
for DIR in os.listdir('.'):
    if DIR != 'Class' and os.path.isdir(DIR):
        D1, D2 = DIR.split("-")
        D1 = int(D1)
        D2 = int(D2)
        for FILE in os.listdir(DIR):
            SPLIT_FILE = FILE.split('.')
            if SPLIT_FILE[2] == 'dbz':
                D = -int(SPLIT_FILE[1].split('-')[0])+1
                f = bz2.BZ2File(DIR + '/' + FILE)
                seq = f.read().split('\n');
                for i in range(5000):
                    h_invs_str = seq[i].strip()
                    if len(h_invs_str) == 0:
                        h_invs = [ ]
                    else:
                        h_invs = [ int(hi) for hi in h_invs_str.split(' ') ]
                    if i % 2 == 0:
                        D += -3
                    else:
                        D += -1
                    if h_invs != []:
                        h = 1
                        for hi in h_invs:
                            h *= int(hi)
                        if h <= ClassBound:
                            if disc_class.has_key(h): 
                                disc_class[h].append(tuple([D] + h_invs))
                            else:
                                disc_class[h] = [tuple([D] + h_invs)]
        print "Finished reading discriminant %s-%s" % (D1, D2)

for h in range(1,ClassBound+1):
    hhh = _pad_int_str(str(h),6)
    filename = 'Class/class.' + hhh + '.db'
    f = open(filename, 'w')
    try:
        class_discs = disc_class[h]
    except:
        class_discs = []
    for class_seq in class_discs:
        D = class_seq[0]
        _, c = fundamental_discriminant(D)
        f.write("%s %s" % (D, c))
        for hi in class_seq[1:]:
            f.write(" %s" % hi)
        f.write("\n");
    f.close()
    os.system('bzip2 -c ' + filename + ' > ' + filename + 'z')
    os.system('chmod a+r ' + filename + 'z')
    os.system('rm ' + filename)
